=== 4.2.2 / 2024-06-24

* 1 bug fix:

  * Fix errors created when string literals are frozen.

=== 4.2.1 / 2024-05-21

* 1 minor enhancement:

  * Raise error if readme file is improperly structured.

* 1 bug fix:

  * Fix NoMethodError: undefined method 'verbose'. (adangel)

=== 4.2.0 / 2024-01-12

* 2 minor enhancements:

  * Extended hoe/racc to be multitask! ruby_parser goes from 8.5s to 1.2s!
  * Extended hoe/racc to build .yy files to allow for multi-file generation.

* 1 bug fix:

  * Fixed missing dep declaration on oedipus_lex.

=== 4.1.0 / 2023-11-16

* 1 minor enhancement:

  * Added Hoe::Cov#cov_filter accessor.

* 2 bug fixes:

  * Removed use of Gem.bin_wrapper. rdoc is now just rdoc.
  * Removed use of Gem.default_exec_format. gem is now just gem.

=== 4.0.5 / 2023-07-25

* 1 bug fix:

  * sow: Fixed nested module directory creation. (chriscz)

=== 4.0.4 / 2023-06-06

* 1 minor enhancement:

  * Bumped minimum ruby to 2.7. So done.

* 1 bug fix:

  * Fixed a readme parsing oddity for section headers w/ multiple words that collide.

=== 4.0.3 / 2023-05-02

* 1 bug fix:

  * Ensure that license name is a string.

=== 4.0.2 / 2023-01-21

* 1 minor enhancement:

  * Bump minimum ruby version to 2.6+. Can't wait to drop 2.6.

* 1 bug fix:

  * Fix for rubygems method error. Version used to respect #=~, now needs to #to_s first.

=== 4.0.1 / 2022-12-17

* 1 bug fix:

  * Add extra checks to release_sanity to ensure history file is updated before release.

=== 4.0.0 / 2022-12-16

* 3 major enhancements:

  * Removed Minitest::TestTask. Shipped with minitest 5.16+ now!
  * Removed direct support for rspec, test/unit. Still extendable tho.
  * Removed support for old style readme parsing.

=== 3.26.0 / 2022-10-20

* 2 minor enhancements:

  * Added warning to bundled minitest/test_task.
  * Removed dead rcov plugin and added (simple)cov plugin.

* 1 bug fix:

  * Fixed test task load path issue, prepend Hoe.include_dirs to ensure they come first.

=== 3.25.0 / 2022-08-18

* 1 minor enhancement:

  * Added otp_command config option for OTP auth on gem push.

* 1 bug fix:

  * Use sh instead of system during gem install to raise on error.

=== 3.24.0 / 2022-06-20

* 3 minor enhancements:

  * Add bindir and homepage accessor methods. (dsisnero)
  * Don't auto-intuit values if they're already set. (dsisnero)
  * Use bindir to determine executables. (dsisnero)

=== 3.23.1 / 2022-01-04

* 1 bug fix:

  * Fixed loading config files for ruby 3.1's now default YAML.safe_load_file.

=== 3.23.0 / 2021-05-29

* 2 minor enhancements:

  * Bump racc (plugin) dependency.
  * Removed ruby18! and ruby19! methods. ugh

=== 3.22.3 / 2021-01-10

* 1 bug fix:

  * Bumped ruby version to include < 4 (trunk).

=== 3.22.2 / 2020-08-31

* 1 bug fix:

  * Bumped ruby version to include 3.0 (trunk).

=== 3.22.1 / 2020-02-12

* 1 bug fix:

  * Avoid calling parse_urls if URL metadata are already set. (flavorjones)

=== 2.22.0 / 2020-02-09

* 4 minor enhancements:

  * Added metadate mapping for 'docs'.
  * Added rdoc extension to the history and readme file finder globs.
  * Extended readme parsing to more intelligently deal with markup sections.
  * Refactored intuit_values to take the file content as an arg.

* 2 bug fixes:

  * Fixed ordering of test_prelude vs framework in Minitest::TestTask. (flavorjones)
  * Fixed wiring of test_prelude into Minitest::TestTask.create. (flavorjones)

=== 3.21.0 / 2020-01-11

* 2 minor enhancements:

  * Added support for wiki_uri and mailing_list_uri. (JuanitoFatas)
  * Load encrypted private key using ENV['GEM_PRIVATE_KEY_PASSPHRASE'] as passphrase. (larskanis)

* 5 bug fixes:

  * Add require_ruby_version for 2.1+. (MSP-Greg)
  * Fix a ruby 2.7 keyword arg deprecation. (anatol)
  * Fix debug_gem task when you have a signing_key and broken rubygems (< 3.1.0).
  * Fixed shadowed variable and json output for minitest's test:isolated task.
  * Minor tweak to make hoe load when openssl isn't available.

=== 3.20.0 / 2019-11-09

* 2 minor enhancements:

  * Added <test>:isolated task that runs tests in parallel. Replaces <test>:dep task.
  * Bumped rake dependency to be < 15.

=== 3.19.0 / 2019-10-29

* 4 minor enhancements:

  * Added deprecation to parse_urls for ancient url array form.
  * Added support for gemspec metadata. (viraptor)
  * Hoe#parse_urls now returns a hash no matter what
  * Removed looong deprecated Hoe#url/url= methods.

* 1 bug fix:

  * Fixed sow for ruby 2.6 deprecations in ERB. (felipec)

=== 3.18.1 / 2019-09-14

* 1 minor enhancement:

  * Added deprecations to minitest/test_task: TESTOPTS, N (for #threads), FILTER.

* 3 bug fixes:

  * Fixed one use of Array.prepend on ruby 2.3-2.4.
  * Removed FILTER/N/X handling from hoe/test.rb in favor of minitest/test_task.rb.
  * Sort globs before shuffling to normalize different file systems.

=== 3.18.0 / 2019-05-25

* 1 major enhancement:

  * Added Minitest::TestTask (will move to minitest proper soon)

* 8 minor enhancements:

  * Added 'multiruby_skip' config so it can be in global ~/.hoerc.
  * Added Hoe.include_dirs to allow tasks to probe directly.
  * Added X=exclude_pattern to the test plugin. Can be used in conjunction with N=select_pattern.
  * Deprecated Hoe::Test.make_test_cmd      (argue with me!)
  * Deprecated Hoe::Test.try_loading_rspec  (argue with me!)
  * Deprecated Hoe::Test.try_loading_rspec2 (argue with me!)
  * Deprecated testunit support             (argue with me!)
  * Switched normally hoe-generated test tasks over to use Minitest::TestTask.

* 1 bug fix:

  * Fixed incompatibility with rubygems 3.x. (drbrain)

=== 3.17.2 / 2019-03-13

* 1 bug fix:

  * Fixed gem sign breakage caused by rubygems update. Tested against rubygems 3.0.2

=== 3.17.1 / 2018-09-06

* 1 bug fix:

  * Bumped dependencies on rdoc and rake for latest majors.

=== 3.17.0 / 2018-03-17

* 2 minor enhancements:

  * Added task check_key to see if your signing cert is expired or not.
  * Bump rdoc dependency to range from 4.x to 5.x.

* 1 bug fix:

  * Fixed ridocs rake task.

=== 3.16.2 / 2017-11-21

* 2 bug fixes:

  * Make missing history/readme situations more resilient and informative. (kemonomachi)
  * Make missing urls value just warn.

=== 3.16.1 / 2017-07-17

* 2 bug fixes:

  * Better handling of rdoc finding failures.
  * Fixed bug making system calls w/ empty string in array? No clue.

=== 3.16.0 / 2017-01-03

* 1 minor enhancement:

  * Updated compiler plugin dependency for rake-compiler to 1.x.

* 2 bug fixes:

  * Fixed rdoc cmd to be more resilient to ruby version changes (w/ isolate)
  * Relaxed rake dependency to < 13 to fix against latest release.

=== 3.15.3 / 2016-11-17

* 1 bug fix:

  * Call Gem::Specification.reset after installing a gem. (segiddins)

=== 3.15.2 / 2016-10-09

* 2 bug fixes:

  * Add noop clobber_docs and clobber_package tasks in case they are disabled.
  * Moved activate_plugin_deps to post_initialize.

=== 3.15.1 / 2016-06-15

* 1 bug fix:

  * rake newb does a better job of activating gems it had to install. (duckinator)

=== 3.15.0 / 2016-03-25

* 1 minor enhancement:

  * Added ruby version declarations for hoe-spec. ruby20!

* 2 bug fixes:

  * Fixed running rdoc if it was satisfied outside of GEM_HOME.
  * Relaxed requirement on rake to include new rake 11.x. (hsbt)

=== 3.14.2 / 2015-09-14

* 1 minor enhancement:

  * Updated Hoe.pdf to reflect reality (removed all rubyforge references).

* 1 bug fix:

  * Fixed extension paths. Again. Damnit. I normally don't release after midnight.

=== 3.14.1 / 2015-09-13

* 1 bug fix:

  * *sigh* fixed bug setting up extensions data for spec.

=== 3.14.0 / 2015-09-12

* 5 minor enhancements:

  * Added so_name variable to bin/sow for using hoe w/ c-extensions.
  * Default config now excludes tmp, .git, and .bundle.
  * Extended :compiler plugin to define #extension for hoe spec decls.
  * Failures to detect/load rake-compiler are handled gracefully.
  * Removed generation of synthesized .gemtest file. Dead.

* 1 bug fix:

  * Fix PRERELEASE= for packaging against newer versions of rubygems. (drbrain)

=== 3.13.1 / 2015-02-03

* 1 bug fix:

  * Remove deprecated test_files from spec. (igas)

=== 3.13.0 / 2014-09-26

* 2 minor enhancements:

  * Added ext_name to sow template expansion variables.
  * Added oedipus version to generation output

=== 3.12.0 / 2014-04-23

* 3 minor enhancements:

  * Added :rdoc plugin.
  * Renamed History.txt to History.rdoc.
  * Renamed README.txt to README.rdoc.

=== 3.11.0 / 2014-04-02

* 1 minor enhancement:

  * Added test:slow task so I don't have to remember sort's flags anymore. YAY for UNIX!

=== 3.10.0 / 2014-03-14

* 1 major enhancement:

  * Removed all references to rubyforge, including the rubyforge plugin.

* 1 minor enhancement:

  * Updated template project (minitest usage, readme format, etc)

=== 3.9.0 / 2014-02-10

* 1 minor enhancement:

  * Added irb task.

* 1 bug fix:

  * Properly constrain rubyforge dependency to avoid warnings. Prolly remove entirely soon. (halostatue)

=== 3.8.1 / 2014-01-22

* 2 minor enhancements:

  * Added C=<#cpus> for minitest parallel testing support.
  * Added test_cmd task to make running tests in subcommands (eg profiling) easy.

* 1 bug fix:

  * Fixed bug when mixing TESTOPTS & N.

=== 3.8.0 / 2014-01-15

* 2 minor enhancements:

  * Change racc plugin to support oedipus_lex, not rexical.
  * Switched .rb to .rex rule to oedipus_lex.

=== 3.7.4 / 2014-01-06

* 1 bug fix:

  * Fix path in template/Rakefile.erb since we now have template styles. (mikestok)

=== 3.7.3 / 2013-12-13

* 1 bug fix:

  * Quell warnings in sow on ruby 2.0. (teoljungberg)

=== 3.7.2 / 2013-12-05

* 1 bug fix:

  * Apparently getting files in a different order on osx on ruby 2.1. (sanemat)

=== 3.7.1 / 2013-08-19

* 1 minor enhancement:

  * Added N=testname option to the test task to shortcut TESTOPTS='-n testname'

=== 3.7.0 / 2013-07-24

* 1 minor enhancement:

  * Warn and default to MIT license if not set.

=== 3.6.3 / 2013-06-20

* 1 bug fix:

  * Fixed problems with shell redirection on non-bash systems. (kou)

=== 3.6.2 / 2013-05-29

* 1 minor enhancement:

  * Um... the default test lib should probably be minitest, not testunit.

=== 3.6.1 / 2013-05-10

* 2 bug fixes:

  * Define a blank test task just in case nothing is found
  * Fixed an ancient test to use capture_subprocess_io. More reliable.

=== 3.6.0 / 2013-04-18

* 5 minor enhancements:

  * Added built-in support for markdown.
  * Renamed rubyforge_name to group_name.
  * Aliased and deprecated rubyforge_name from group_name.
  * Strip <> from parse_urls for markdown style raw urls.
  * intuit_values looks for README.md and History.md as well as txt.

* 1 bug fix:

  * Fix file_name regex for test file. (bhenderson/veganstraightedge)

=== 3.5.3 / 2013-04-09

* 1 minor enhancement:

  * Updated publish plugin to depend on rdoc 4.x.

=== 3.5.2 / 2013-03-18

* 1 bug fix:

  * 1.9: fixed warning of ambiguous args in bin/sow. (amesee)

=== 3.5.1 / 2013-02-22

* 1 bug fix:

  * Fixed use of Gem::Specification.find_by_name for ruby 2.0. (haramako)

=== 3.5.0 / 2013-01-22

* 1 minor enhancement:

  * Added optional cmd field in blog setup for hoe/publish

=== 3.4.1 / 2013-01-16

* 1 bug fix:

  * Fixed MiniTest const for older stock ruby minitests. (illuminerdi)

=== 3.4.0 / 2012-12-18

* 2 minor enhancements:

  * Splatted version arg on require_rubygems_version and require_ruby_version.
  * Switch default template test file to minitest

=== 3.3.1 / 2012-11-23

* 1 minor enhancement:

  * Updated rake dep to be >= 0.8 and < 11.0 for the new wack version scheme. (MichaelXavier)

=== 3.3.0 / 2012-11-12

* 3 minor enhancements:

  * Added Sow#make_sub_modules. (bhenderson)
  * Hoe.normalize_names now returns test class name separately. (bhenderson)
  * Sow now generates test and impl files with proper namespacing. (bhenderson)

=== 3.2.0 / 2012-11-09

* 3 minor enhancements:

  * Added flog_method and defaulted it to max_method
  * Changed flog_threshold to 20, 2x the industry average. Be strong. You can do it.
  * Hoe#timebomb will now default finis/start values to 1/1 and 12/31 of the current year if not specified.

=== 3.1.1 / 2012-11-03

* 1 bug fix:

  * Fixed ridocs command args. (bikeNomad)

=== 3.1.0 / 2012-09-21

* 1 minor enhancement:

  * Added Hoe#licenses and Hoe#license for declaring your gem's license. (flavorjones)

* 1 bug fix:

  * Rake 0.8.7 sets verbose flag to true, breaking 2 tests. (michelboaventura)

=== 3.0.8 / 2012-08-20

* 1 bug fix:

  * Set test_globs default value to pick up test/*spec* files as well. (millisami)

=== 3.0.7 / 2012-08-07

* 1 minor enhancement:

  * Added quote from DrNic about manifests to readme.

=== 3.0.6 / 2012-05-15

* 1 minor enhancement:

  * Added install_plugins to the newb task

=== 3.0.5 / 2012-05-07

* 1 bug fix:

  * Fixed ridocs argument handling (erikh)

=== 3.0.4 / 2012-05-01

* 1 bug fix:

  * Removed rubygems/deprecated and rolled my own for users on older rubygems

=== 3.0.3 / 2012-04-09

* 2 bug fixes:

  * Fixed racc plugin's gem dependency activation
  * Fixed rake multi's use of multiruby_skip.

=== 3.0.2 / 2012-04-03

* 1 bug fix:

  * Generate urls list properly in #announcement if you use k/v form

=== 3.0.1 / 2012-03-26

* 1 minor enhancement:

  * Uniqify hoe plugins in sow Rakefile template. (evanphx)

* 3 bug fixes:

  * Fixed have_gem? checks in the install_plugins task to match the install_gem calls.
  * Fixed homepage handling when bullet list used in readme. (evanphx)
  * Removed deprecated use of #url in publish plugin

=== 3.0.0 / 2012-03-20

* 3 major enhancements:

  * Added activate_plugin_deps phase to plugin loading.
  * Removed long deprecated Hoe.new { block }.
  * Removed long deprecated handling of improper dependencies.

* 3 minor enhancements:

  * Added deprecation warnings to Hoe#url and Hoe#url=. Already deprecated for 9 mo.
  * Reworked all the plugins to use activate_XXX_deps, as necessary.
  * Switched internal usage of #url to #urls.

* 2 bug fixes:

  * Fixed failures in the publish_docs task when remote directory times cannot be changed (such as on rubyforge).
  * Fixed isolate setup for the racc plugin

=== 2.16.1 / 2012-03-13

* 2 bug fixes:

  * Fixed missing dependency for .gemtest creation (larskanis)
  * Fixed the rdoc/rcov commands to use sh. Oops.

=== 2.16.0 / 2012-03-06

* 9 minor enhancements:

  * Added Gem.bin_wrapper to provide API to bin wrapped files.
  * Added check_manifest task to compile_tasks in the compiler plugin.
  * Decoupled from rcov task. Solves isolate/hoe bootstrap issues.
  * Decoupled from rdoc tasks. Solves isolate/hoe bootstrap issues.
  * Updated default exclude config to skip extconf.h and .o files.
  * Updated known 3rd party plugin list in readme.
  * Warn against using system installed rake (eg osx ships their own on 1.8).
  * Removed rcov plugin from the default loaded set.
  * Added dev dependency for rcov when the plugin is loaded.

* 2 bug fixes:

  * Fix Rake::DSL include warnings.
  * Removing check_manifest from prerelease. (should be pushed to the hoe-git plugin)

=== 2.15.0 / 2012-02-29

* 5 minor enhancements:

  * Added Hoe::bad_plugins which returns plugins that could not be found
  * Added post_blog_zenweb to post releases to my blog's jekyll-like format
  * Added the install_plugins task
  * Documented the blogs .hoerc entry.
  * Revamped post_blog task to allow for local file based blogs.

=== 2.14.0 / 2012-02-20

* 9 minor enhancements:

  * .rdoc files are now automatically added to the extra_rdoc_files list.
  * Added Hoe#read_manifest
  * Added check_manifest to the prerelease task to prevent broken releases.
  * Added extra duplicate dependency checking.
  * Hoe#with_config merges the local and home configuration atop Hoe::DEFAULT_CONFIG to allow plugins to supply new defaults.
  * The readme_file and history_file are now automatically guessed from the manifest.  This allows "README.rdoc" to be used automatically.
  * install_gem optionally excludes rdoc/ri generation.
  * rake check_extra_deps excludes rdoc/ri generation. rake install_gem does not.
  * rake multi now just reinvokes rake using multiruby to allow hoe plugins to be invoked.

* 3 bug fixes:

  * Added workaround for check_extra_deps for multi-version dependencies.
  * The publish plugin no longer raises an exception for missing or ancient versions of rdoc.
  * rdoc plugin calls isolate if using isolate

=== 2.13.1 / 2012-02-06

* 1 minor enhancement:

  * :doc task should depend on isolate if activated

=== 2.13.0 / 2012-01-23

* 3 minor enhancements:

  * Added :dcov task so you can easily check documentation coverage.
  * Added Rake monkeypatch so that Task#clear will clear comments. (github)
  * Added coverage sorting and added tmp/isolate to rcov flags

* 2 bug fixes:

  * Quelled 1.9.3 warning. (erikh)
  * rcov plugin should invoke isolate task if isolate plugin is being used.

=== 2.12.5 / 2011-12-19

* 3 minor enhancements:

  * Make hoe noisy about missing plugins again.
  * Normalize dev/runtime deps: dev + runtime = runtime.
  * Add support for per-project .hoerc overrides. (ged)

=== 2.12.4 / 2011-11-28

* 3 bug fixes:

  * Fixed Hoe.read_utf to work on both 1.8 and 1.9. Unicode files FTW! (tenderlove)
  * Moved the rdoc dependency to the publish plugin from hoe-seattlerb.
  * Only load rdoc once to fix test loading bugs.

=== 2.12.3 / 2011-09-06

* 1 bug fix:

  * Hoe was loading rdoc early... delay and isolate will be happier

=== 2.12.2 / 2011-08-24

* 2 minor enhancements:

  * Added recursive chmod to docs task to ensure group write-ability (kleb)
  * Improve error message when no manifest found. (Apparently some linux packagers remove manifest files)

* 3 bug fixes:

  * Added missing minitest/autorun require (NOT reported by fedoraproject.org)
  * Fix for RSpec support broken in 0dc6b2f (ged)
  * Fix for the edgiest of edge cases (-Ku in ruby19... ummm, yeah)

=== 2.12.1 / 2011-08-22

* 2 bug fixes:

  * Fixed a test that fails on non-privileged (rvm/multiruby) setups
  * RbConfig is used instead of Config to remove a 1.9.3 warning.

=== 2.12.0 / 2011-08-15

* 2 minor enhancements:

  * Forcibly copy file specified in --main to index.html. (ewong)
  * need_tar now defaults to false.

* 4 bug fixes:

  * Don't attempt to require RSpec 1 in an RSpec 2 environment. (monde)
  * Fixed test/packaging issue when wrapping hoespec in namespace. (damphyr)
  * Fixed tests for jruby. (sferik)
  * Hoe.load_plugins removes bad entries so plugin? returns false for unloaded plugins.

=== 2.11.0 / 2011-08-08

* 2 minor enhancements:

  * Bypass sudo on install_gem if GEM_HOME is writable (ala rvm).
  * rcov plugin should set libs to lib, test, and '.'. (tenderlove)

* 1 bug fix:

  * Fixed windoze detection on jruby. *sigh* (myabc)

=== 2.10.0 / 2011-06-30

* 3 minor enhancements:

  * Added parse_urls to deal with array and hash style url lists in README.txt.
  * Added urls accessor.
  * Deprecated url accessors.

* 1 bug fix:

  * Specified wrong version of racc in racc plugin.

=== 2.9.6 / 2011-06-22

* 3 bug fixes:

  * Fixed hoe dep to be a spermy (~>) dep
  * Hard coded rake dependency as ~> 0.8 so we don't collide with other libs
  * Removed circular dependency check. Hasn't been needed in a long while.

=== 2.9.5 / 2011-06-21

* 2 minor enhancements:

  * Extended #dependency to work post-spec creation in case a task wants to add a dep.

* 4 bug fixes:

  * Fixed dependency for :inline plugin.
  * Fixed minor 1.9.3 warnings.
  * Fixed sow to obey gem naming conventions.  It no longer munges - to _.
  * Switched hoe deps from >= to ~>.

=== 2.9.4 / 2011-04-01

* 1 minor enhancement:

  * check_manifest now fails when there is a diff. AKA, drbrain was
    lazy and it is somehow my fault. If anything, it is jbarnette's
    fault for not building any brains into hoe-git the way that my
    hoe-perforce plugin works. I mean, c'mon... how hard is it to
    validate the manifest before you release? I do it all the time
    and twice on sundays. BAH! Damn kids! Get off my lawn!

=== 2.9.3 / 2011-04-01

* 1 minor enhancement:

  * Cleanup for rubygems 1.7 deprecations

=== 2.9.2 / 2011-03-31

* 7 minor enhancements:

  * Added :none as a testlib option to let you do whatever you want. (phiggins)
  * Added Hoe#dependency(name, version, type = :runtime) for cleaner hoe specs.
  * Added NOSUDO option to `rake gem_install`. (nihildeb)
  * Include Rake::DSL to support future versions of rake
  * Multiruby now skips mri_trunk if multiruby_skip includes 1.9
  * Test#make_test_cmd now sorts test files (mostly for testing)
  * Try using psych before syck.

* 3 bug fixes:

  * Clean generated extension library too
  * Fixed a bug with sow -d or -t
  * Fixed plugin activation via ~/.hoerc. (ged)

=== 2.9.1 / 2011-02-05

* 1 minor enhancement:

  * Sow now creates all template directories before dealing with anything else

* 3 bug fixes:

  * Fixed dependency order bug with prereleases [erikh]
  * Fixed sanity check for prereleases.
  * Fixed sow when passed no args. [erikh]

=== 2.9.0 / 2011-01-31

* 11 minor enhancements:

  * Added Hoe::Package#pkg_path to make package hook writing easier.
  * Added Hoe::Test#test_prelude to allow for code to run before test loading.
  * Added plugin?(name) to allow for easier plugin guarding in hoe spec.
  * Added support for multiple template dirs for sow.
  * Added support for rubygems-test. See http://www.gem-testers.org/
  * Clean up sow a LOT using: include FileUtils::Verbose
  * Don't warn about missing plugins without rake -t
  * Hoe requires Gem::PackageTask from RubyGems 1.4+
  * Moved post_news from publish to rubyforge
  * Plugins can now be loaded from a +plugins+ array in ~/.hoerc
  * rubyforge plugin now uses plain globs to push. Fixes releases for rubygems itself

* 4 bug fixes:

  * Failed plugins should notify on both trace and debug.
  * Fixed rdoc_dir for custom rdoc locations
  * Fixed require 'rubyforge' that was too late
  * Fixed sow to properly rename dirs depth first

=== 2.8.0 / 2010-12-08

* 6 minor enhancements:

  * Added PRE=a.1 variable to package and release tasks. (ged)
  * Added compiler plugin to support rake-compiler. (tenderlove)
  * Added known_plugins task and updated included and 3rd party plugins doco
  * Added racc/rex plugin!
  * Extended sow's Rakefile template to dynamically include installed plugins
  * Turned off rubyforge plugin by default. (tenderlove's whining)

=== 2.7.0 / 2010-11-15

* 2 minor enhancements:

  * Added new plugin: gem_prelude_sucks. (jbarnette)
    * Activate under 1.9 if you don't want it messing with you.
  * Added rspec2 support (bleything)

* 1 bug fix:

  * require uri in hoe/deps (raggi)

=== 2.6.2 / 2010-08-31

* 1 minor enhancement:

  * Updated inline dependency when using inline plugin

* 1 bug fix:

  * Fixed timebomb to bottom out properly on the end value

=== 2.6.1 / 2010-06-02

* 2 bug fixes:

  * Fix up hoe to be happy when rubyforge is missing or misconfigured
  * Fixed dep tasks to deal with broken rubygems changes RF#27847 (mjwillson)

=== 2.6.0 / 2010-03-27

* 6 minor enhancements:

  * Added '.' to load path for (bad) 1.9.2 changes
  * Added rdoc_locations array to the publish plugin to allow for
    multiple arbitrary rdoc locations
    * Refactored old rubyforge rdoc location to the rubyforge plugin.
  * Added require_ruby_version and require_rubygems_version.
  * Cleaned up dep tests
  * Hoe now depends on rubygems 1.3.6 instead of the gemcutter gem.
  * Remove ext from default_ruby_flags and require_paths. (luis)

* 2 bug fixes:

  * Fixed test command to use '--' before filter args
  * Tweaked .hoerc error to point to a fix.

=== 2.5.0 / 2010-01-06

* 8 minor enhancements:

  * Add extra dirs to rcov include path if needed.
  * Added Hoe#dependency_target to make dependencies easier to declare.
  * Added extra doco to describe how auto-population works.
  * Added more doco to readme.
  * Don't bother posting news to rubyforge.
  * Hoe::Inline plugin now deals with X::Y by flattening the name.
  * Merged some of Hoe.pdf to README.txt and further improved doco.
  * Pushed gemcutter & rubyforge dependencies down to the plugins.

* 2 bug fixes:

  * Fix perms on Hoe.pdf after copying.
  * Fixed Hoe rdoc problem caused by gemcutter plugin.

=== 2.4.0 / 2009-12-08

* 6 minor enhancements:

  * Added Hoe.pdf
  * Added gemcutter plugin (raggi)
  * Added newb plugin. (jbarnette)
  * Improved README.txt
  * Improved rdoc
  * Refactored rubyforge task to plugin. (jbarnette)

=== 2.3.3 / 2009-08-07

* 6 minor enhancements:

  * #plugin now uniq's contents. (asarih)
  * Added extra warnings if manifest is borked.
  * Added link to full doco.
  * Deprecated plain string dependencies, auto-fill with '>= 0'.
  * Improved doco with some code examples.
  * Moved version check from package task to prerelease task.

=== 2.3.2 / 2009-06-30

* 1 minor enhancement:

  * splat all gems on release. (luis lavena)

* 3 bug fixes:

  * Fix File.read_utf on ruby 1.9 for UTF-8 files
  * Force read_utf to open file ascii-8bit. UGH. ruby 1.9 encoding is a PITA.
  * Version regex needs to allow multiple spaces for OCD coders.

=== 2.3.1 / 2009-06-24

* 2 minor enhancements:

  * Removed email.txt from clean_globs, added TAGS.
  * Use Gem::PackageTask if available, since Rake's package task will go away

* 2 bug fixes:

  * Added require time where used
  * JB nitpicks too much. fixed templates.

=== 2.3.0 / 2009-06-23

* 1 major enhancement:

  * Plugins can no longer be self-activating.

* 8 minor enhancements:

  * All hoe plugins are pre-activated.
  * Allow RDoc title to be set via spec_extras['rdoc_options'].
  * Cleaned up plugin activation.
  * History intuition extended for markdown. drnic/jbarnette
  * Move RDoc task requires to hoe/publish.rb.
  * Only activated plugins are loaded, extended, and activated.
  * Plugin loading deferred until hoe-spec creation, allowing proper meta-plugins.
  * inline plugin adds RubyInline dependency and hooks clean task.

* 2 bug fixes:

  * Fixed developer load order error in load_plugins.
  * rcov should use test_globs. apatterson

=== 2.2.0 / 2009-06-17

* 8 minor enhancements:

  * Alter task descriptions to say what plugin they come from. jbarnette
  * Fix and improve generate_key task.  Patch #20441 by Matthew Kent.
  * Hoe.plugin can take multiple names. jbarnette
  * Increase configurability of RDoc tasks.  Patch #19597 by Sylvain Joyeux.
  * Refactored and renamed email task to debug_email, removed from announce.
  * Removed email task from announce task.
  * Switched to seattlerb plugin
  * check_extra_deps now installs developer dependencies as well

* 3 bug fixes:

  * Fixed blogs entry in DEFAULT_CONFIG.
  * activated but missing plugins are properly skipped now
  * exclude field was missing from DEFAULT_CONFIG

=== 2.1.0 / 2009-06-14

* 6 minor enhancements:

  * Added File::read_utf to strip out UTF BOM marker. Fixes nokogiri. (tenderlove)
  * Now using the minitest plugin.
  * Refactored :release task to facilitate other plugins.
  * Version intuiting now only bombs on packaging, allowing check_manifest.
  * release now has prerelease, postrelease deps.

* 1 bug fix:

  * Fixed version intuiting to allow for beta versions (eg, 1.2.3.beta.4)

=== 2.0.0 / 2009-06-02

* 3 major enhancements:

  * Added a plugin system and extracted nearly everything into separate plugins.
  * Added Clean, Debug, Deps, Flay, Flog, Inline, Package, Publish, Rake, Rcov, Signing, and Test plugins

* 9 minor enhancements:

  * Added Hoe::spec replacing old Hoe.new spec form. Now with DSL flavors!
  * Added DEFAULT_CONFIG so plugins can add to it.
  * Added pluggable! to declare your package depends on rubygems 1.3.1+.
  * Changes are now included in the gem's description.
  * Deprecated Hoe.new spec form.
  * Filled in all the blanks on rdoc.
  * Refactored nearly all the spec logic down to much smaller/cleaner pieces.
  * Updated templates to use new form. No clue how best to update yours. :P
  * Version number is now auto-searchable by grepping in all the files.

=== 1.12.2 / 2009-04-16

* 1 minor enhancement:

  * Removed rcov_info.

* 2 bug fixes:

  * clean globs should have coverage* glob.
  * rcov task should create coverage.info file for tools.

=== 1.12.1 / 2009-03-31

* 1 bug fix:

  * Added Rake.all_tasks because rake architecture sucks.
    * YAY! Go view http://technonancy.us/ !!

=== 1.12.0 / 2009-03-31

* 6 minor enhancements:

  * Added Rake.undo.
  * Added from vlad: Rake.application.all_tasks and Rake.clear_tasks.
  * Added log files to default excludes. (technonancy)
  * Refactored gem install code and extended to work with jruby
  * Refactored run_tests into make_test_cmd, enabling use in tasks. (jbarnette)
  * Use RDoc::Task instead of Rake::RDocTask, if available.

* 1 bug fix:

  * Fixed incorrect usage. (jmhodges)

=== 1.11.0 / 2009-03-16

* 2 minor enhancements:

  * Added timebomb method. Set flay/flog thresholds to degrade over time.
  * Switched to flog's new FlogTask, added flog_threshold.

=== 1.10.0 / 2009-03-09

* 2 minor enhancements:

  * Switched to flay's new FlayTask, added flay_threshold.
  * generate_key now creates the certificate package automatically.

* 1 bug fix:

  * Fixed generate_key if more than one developer on the project.

=== 1.9.0 / 2009-02-26:

* 7 minor enhancements:

  * Added flog, flay, and rdoc tasks.
  * Added ~/.hoe_template and basic erb templating to sow.
  * install_gem automatically installs missing dependencies. From Dr. Nic.
  * Parameterized history and readme paths for github users (*sigh*).
  * Added rspec support including having both tests and specs.
  * Match RubyGems' RDoc behavior and removed rdoc_pattern attribute.  Use
    extra_rdoc_files instead.
  * Added testlib and SUPPORTED_TEST_FRAMEWORKS to switch your testing library.

* 1 bug fix:

  * Fixed rdoc title command-line parameters.

=== 1.8.3 / 2009-01-20:

* 1 minor enhancement:

  * Refactored sow's naming code to Hoe.normalize_names and wrote some
    tests to flush out inconsistencies.

=== 1.8.2 / 2008-10-24:

* 1 minor enhancement:

  * Now asks Inline for known inlined classes if you package w/ INLINE=1.

=== 1.8.1 / 2008-10-22

* 1 bug fix:

  * Fixes for windows compatibility from Luis Lavena.

=== 1.8.0 / 2008-10-09

* 5 minor enhancements:

  * Added Hoe.add_include_dirs to make setting up rake deps easier.
  * Removed unused optional group arg in sow.
  * Added testlib variable so you can specify what test library to use.
  * Added deps:list to help you review dependent projects.
  * Added deps:email to help you communicate with dependent projects.
  * Added deps:fetch to help you search through dependent projects.

=== 1.7.0 / 2008-06-30

* 3 minor enhancements:

  * Use rdoc 2.x gem if available. Eric likes his backslashes.
  * Added extra_dev_deps for new rubygems developer dependencies.
    * Switched hoe to dev dep. Fork off, bitches.
  * Finally got a sane test that does something. Hey... it's a start.

=== 1.6.0 / 2008-06-18

* 1 minor enhancement

  * blog categories! Defaults to array with project's name. Thanks Aaron!

=== 1.5.3 / 2008-05-20

* 1 bug fix

  * hoe really really needs better tests. I suck. :/

=== 1.5.2 / 2008-05-20

* 4 minor enhancements:

  * Added multiruby_skip attribute for 'rake multi' version invalidation.
  * Improved error messages when files are missing.
  * Added rubygems post_install_message accessor. Thanks to Dr. Nic.
  * Cleaned up alternative_name... I didn't get it.

* 1 bug fix:

  * Removed require of rake/contrib/sshpublisher to fix 1.9.

=== 1.5.1 / 2008-03-04

* 2 minor enhancements:

  * Removed install/uninstall tasks. Too buggy. Gems do a better job.
  * Added cleaning of rbc files to default list

* 5 bug fixes:

  * Correctly deal with errors intuiting history and readme files. Thanks Aaron!
  * Fixed rdoc title. Thanks, Sander!
  * Fixed sow to match new Rakefile and History format. Thanks, me!
  * Moved test/unit to the front for rake test. Fixes use of miniunit.
  * Renamed shadowed variable.

=== 1.5.0 / 2008-01-30

* 9 minor enhancements:

  * Added autopopulation of changes from History.txt.
  * Added autopopulation of urls from History.txt.
  * Added autopopulation of description from History.txt
  * Added autopopulation of summary from description.
  * Added description_sections to declare what sections of readme to use.
  * Added summary_sentences to declare how many sentences you want in summary.
  * Added developer(name, email) to cleanly populate both author/email arrays.
  * author and email now default to "doofus".
  * author and email warn that they'll blow up on 2008-04-01.

=== 1.4.0 / 2007-12-20

* 1 major enhancement:

  * rake package now supports INLINE=1 and FORCE_PLATFORM=whatever.
    * Supports ruby_inline extensions.
    * Contributed by Luis Lavena. Thanks Luis!

=== 1.3.0 / 2007-08-13

* 1 major enhancement:

  * Hoe now builds signed gems automatically.  Run the generate_key task to
    automatically create a signing key.

* 4 minor enhancements:

  * Extended rdoc pattern to include ext dirs.
  * Fixed dependency adding for versionless dependencies.
  * Added NODOT env var to disable RDoc diagram generation.
  * The config_hoe task automatically merges in new config entries.

=== 1.2.2 / 2007-07-23

* 2 minor enhancements:

  * Added exclude parameter for check_manifest filtering to .hoerc.
  * Documented .hoerc stuffs.

* 1 bug fix:

  * Various (untested) fixes for windows compatibility.

=== 1.2.1 / 2007-05-21

* 8 minor enhancements:

  * Allow for spaces in filenames in manifest. Thanks to Aaron Patterson.
  * Allow rsync flags to be set.
  * Allow rdoc destination directory to be set.
  * Deal with bad line-endings. Stupid windoze users... :(
  * Added WINDOZE check for diff.exe and look for gdiff first.
  * Use gdiff if available, diff otherwise. Allows to work on borked Solaris.
  * Move RDoc to attr* from big 'ol chunk at the top of the class.
  * Basic conversion of history/urls from rdoc to markdown.

* 1 bug fix:

  * Fixed executables regexp to /^bin/.

=== 1.2.0 / 2007-02-13

* 4 minor enhancements:

  * Added more support for ext dirs.
  * Added a simple config file (yaml). Use 'rake config_hoe' to edit.
  * Added post_blog task (thanks Aaron!), configured via config_hoe.
  * Announce task now posts to your blogs and/or publishes API
    depending on config.

=== 1.1.7 / 2007-01-10

* 5 minor enhancements:

  * extra_deps is now self-healing, and ensures no (direct) cycles.
  * cleans check_manifest for CVS projects.
  * rubyforge changes for config.
  * Now uses rsync for publish_docs. YAY for fast!
  * Bug #7193 fix spelling of 'synopsys'.  Submitted by Jacob Atzen.

=== 1.1.6 / 2006-11-29

* 1 bug fix:

  * Fix release to work correctly with need_zip and need_tar.

=== 1.1.5 / 2006-11-29

* 2 minor enhancements:

  * Reduced check_manifest dependencies to just diff for windows.
  * Don't use default author in summary, description or changes.

=== 1.1.4 / 2006-11-12

* 3 minor enhancements:

  * Added need_tar and need_zip to customize package requirements. Stupid windoze.
  * Extended spec_extras to take procs as values. Passes in named parameter.
  * Removed test from require_paths. I thought I already parameterized this. :/

=== 1.1.3 / 2006-11-09

* 6 minor enhancements:

  * Added test_deps, now you can automatically discover test dependency ommisions.
  * Added ext support! Build C extensions with hoe!
  * Gemspec uses test_all.rb or result of test_globs. Tweak those tests.
  * Now uses https to login to rubyforge. Rubyforge crackers beware!
  * Fixed doco and automated updating of it.
  * Added rdoc_pattern. Go doco go!

=== 1.1.2 / 2006-10-22

* 4 minor enhancements:

  * Added -d and -t flags to sow to make dev or trunk subdirs for p4
    and svn projects.
  * Added install_gem to further test gem builds.
  * Added test_globs to customize your test file list.
  * Removed demo.rb from clean_globs. I'm torn on this one.

* 1 bug fix:

  * Fixed bug in install rule.

=== 1.1.1 / 2006-10-11

* 2 bug fixes:

  * Fixed minor problem with subject of email.
  * Fixed problem in test.

=== 1.1.0 / 2006-10-04

* 1 major enhancement:

  * Added sow, a command-line tool for quickly creating new projects.

* 1 minor enhancement:

  * Added check_manifest task

=== 1.0.5 / 2006-10-03

* 8 minor enhancements:

  * Doco cleanup.
  * Removed Manifest.txt from rdoc and added title.
  * Added changeset support.
  * Added spec_extras for easy gemspec attribute setting.
  * Added release_notes, changeset setting for releases.
  * Added paragraphs_of utility method.
  * Added email and rubyforge news announcement tasks.
  * Url attribute may now be an array of urls.

=== 1.0.4 / 2006-09-23

* 1 bug fix:

  * Damnit... I messed up. There is no rubygems gem to be dependent upon. Duh.

=== 1.0.3 / 2006-09-23

* 9 minor enhancements:

  * Added debug_gem rule.
  * Added lots of doco.
  * Added proper deps to hoe for other's gems, and
    rake/rubyforge/rubygems for hoe.
  * Added ridocs to generate ri locally for testing.
  * Added support for multiple authors.
  * Rdoc now includes any top level .txt files.
  * Renamed deploy to release.
  * Renamed upload to publish_docs.
  * publish_docs is now smart about subprojects and missing subdirectories.

* 1 bug fix:

  * Fixed include paths.

=== 1.0.2 / 2006-09-20

* 2 minor enhancements:

  * Wee little tests.
  * Fixed up gemspec's require_paths.

=== 1.0.1 / 2006-09-20

* 5 minor enhancements:

  * Finally got deployment straightened out. Maybe. Some might be on
    rubyforge.org.
  * Added default description and summary.
  * Added dependency mechanism.
  * Improved gemspec debugging.
  * Swapped gem with tgz in deploy... we'd rather screw up on tgz

=== 1.0.0 / 2006-09-19

* 1 major enhancement:

  * Birthday!
